Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic



Namespace Samples.Services.FinanceInfo
	Public Class BaseFinanceInfoFinder
		Implements IFinanceInfoFinder
		''' <summary>
		''' Class constructor
		''' </summary>
		Public Sub New()
		End Sub


		#Region "IFinanceInfoFinder"


		''' <summary>
		''' Indicates the name of the financial info provider
		''' </summary>
		Public Overridable ReadOnly Property ProviderName() As String Implements IFinanceInfoFinder.ProviderName
			Get
				Return "BaseInfoFinder"
			End Get
		End Property


		''' <summary>
		''' Interface member that gets quote information using a random generator
		''' </summary>
		''' <param name="symbols">Comma-separated string indicating symbols to retrieve</param>
		''' <returns>Array of StockInfo objects</returns>
		Private Function IFinanceInfoFinder_FindQuoteInfo(ByVal symbols As String) As StockInfo() Implements IFinanceInfoFinder.FindQuoteInfo
			Return Me.FindQuoteInfo(symbols)
		End Function

		#End Region


		#Region "Protected Virtuals"

		''' <summary>
		''' Gets quotes and related change using a random number generator
		''' </summary>
		''' <param name="symbols">Comma-separated string indicating symbols to retrieve</param>
		''' <returns>NULL</returns>
		Protected Overridable Function FindQuoteInfo(ByVal symbols As String) As StockInfo()
			Return Nothing
		End Function

		#End Region
	End Class
End Namespace