Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Text


Namespace Samples.Services.FinanceInfo
	Public Class DefaultFinanceInfoRenderer
		Inherits BaseFinanceInfoRenderer
		''' <summary>
		''' Class constructor
		''' </summary>
		Public Sub New()
		End Sub

		#Region "Protected Virtuals"

		''' <summary>
		''' Render quotes to a styled HTML table
		''' </summary>
		''' <param name="stocks">Array of the StockInfo objects to render</param>
		''' <returns>HTML message</returns>
		Protected Overrides Function GenerateHtml(ByVal stocks() As StockInfo) As String
			Dim headers() As String = { "SYMBOL", "LAST", "CHANGE", "TIME" }
			Dim columns() As String = { "Symbol", "Quote", "Change", "Time" }

			Dim builder As New StringBuilder()

			' Pay attention to URLs here
			builder.AppendFormat("<table cellpadding='{0}' cellspacing='{1}' border='{2}' rules='{3}' frame='{4}' style='{5}'>", 4, 0, 1, "rows", "hsides", "background-image:url(./images/sfondo.gif);")
			builder.AppendFormat("<tr style='background-color:{0};color:{1};'>", "#6B696B", "white")

			' Define header
			For i As Integer = 0 To columns.Length - 1
				builder.AppendFormat("<th>{0}</th>", headers(i))
			Next i
			builder.Append("</tr><tr>")

			' Define body 
			For i As Integer = 0 To stocks.Length - 1
				Dim stock As StockInfo = stocks(i)
				For j As Integer = 0 To columns.Length - 1
					Dim value As String = CStr(FinanceInfoUtils.GetPropertyValue(stock, columns(j)))
					builder.AppendFormat("<td style='color:{0}' align='{1}'>{2}</td>", (If(value.StartsWith("+"), "green", (If(value.StartsWith("-"), "red", "")))), (If(j = 0, "left", "right")), value)
				Next j
				builder.Append("</tr><tr>")
			Next i


			' Define footer 
			builder.AppendFormat("<td style='background-color:#eeeeee;' align='right' colspan='{0}'><small><i>provided by <b>{1}</b></i></small></td>", columns.Length, stocks(0).ProviderName)
			builder.Append("</tr></table>")

			Return builder.ToString()
		End Function

		#End Region
	End Class
End Namespace