Imports Microsoft.VisualBasic
Imports System
Imports System.ComponentModel



Namespace Samples.Services.FinanceInfo
	Public NotInheritable Class FinanceInfoUtils
		Public Const CONFIG_OFFLINESTOCKSYMBOLS As String = "FinanceInfo_OfflineStockSymbols"
		Public Const CONFIG_ONLINESTOCKSYMBOLS As String = "FinanceInfo_OnlineStockSymbols"
		Public Const CONFIG_RENDERER As String = "FinanceInfo_Renderer"
		Public Const CONFIG_OFFLINEFINDER As String = "FinanceInfo_OfflineFinder"
		Public Const CONFIG_ONLINEFINDER As String = "FinanceInfo_OnlineFinder"


		''' <summary>
		''' Uses reflection to get a property value indirectly
		''' </summary>
		''' <param name="stock">Container object to get the value from</param>
		''' <param name="propName">Name of the property to retrieve</param>
		''' <returns>Value of the specified property</returns>
		Private Sub New()
		End Sub
		Public Shared Function GetPropertyValue(ByVal stock As Object, ByVal propName As String) As Object
			If stock Is Nothing Then
				Return Nothing
			End If

			Dim descriptor As PropertyDescriptor = TypeDescriptor.GetProperties(stock).Find(propName, True)
			If descriptor IsNot Nothing Then
				Return descriptor.GetValue(stock)
			End If

			Return Nothing
		End Function

	End Class
End Namespace
