Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Text
Imports System.Net
Imports System.IO
Imports System.ComponentModel
Imports System.Configuration



Namespace Samples.Services.FinanceInfo
	Public Class OnlineServiceProvider
		Inherits BaseFinanceInfoProvider

		''' <summary>
		''' Class constructor
		''' </summary>
		Public Sub New()
		End Sub


		#Region "Resolvers"

		''' <summary>
		''' Reads the name of the finder component from config (or goes for a default class)
		''' </summary>
		''' <returns>Instance of a class that implements IFinanceInfoFinder</returns>
		Protected Overrides Function ResolveFinder() As IFinanceInfoFinder
			Dim className As String = ConfigurationManager.AppSettings(FinanceInfoUtils.CONFIG_ONLINEFINDER)
			If String.IsNullOrEmpty(className) Then
				Return New YahooFinanceInfoFinder()
			Else
				' NB: assuming the assembly is loaded!!! 
				' Use a different overload of CreateInstance for a more general scenario (class+assembly in a string)
				Dim t As Type = Type.GetType(className)
				Return TryCast(Activator.CreateInstance(t), IFinanceInfoFinder)
			End If
		End Function

		#End Region

	End Class
End Namespace