Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic



Namespace Samples.Services.FinanceInfo
	Public Class RandomFinanceInfoFinder
		Inherits BaseFinanceInfoFinder

		''' <summary>
		''' Class constructor
		''' </summary>
		Public Sub New()
		End Sub


		#Region "Virtuals"

		''' <summary>
		''' Indicates the name of the financial info provider
		''' </summary>
		Public Overrides ReadOnly Property ProviderName() As String
			Get
				Return "FictitiousData .NET"
			End Get
		End Property


		''' <summary>
		''' Gets quotes and related change using a random number generator
		''' </summary>
		''' <param name="symbols">Comma-separated string indicating symbols to retrieve</param>
		''' <returns>Array of StockInfo objects</returns>
		Protected Overrides Function FindQuoteInfo(ByVal symbols As String) As StockInfo()
			' Get an string array to work with
			Dim elements() As String = symbols.Split(","c)

			' Random object
			Dim rnd As New Random()

			' Create return value object
			Dim data As List(Of StockInfo) = New List(Of StockInfo)()


			' Loop through the symbols
			For i As Integer = 0 To elements.Length - 1
				Dim stock As New StockInfo()
				stock.ProviderName = Me.ProviderName
				stock.Symbol = elements(i)
				stock.Day = DateTime.Now.ToShortDateString()
				stock.Time = DateTime.Now.ToShortTimeString()

				' Random quote
				Dim d1 As Double = rnd.NextDouble()
				Dim mult1 As Integer = rnd.Next(1, 100)
				d1 = d1 * mult1
				stock.Quote = d1.ToString("##0.000")

				' Random change
				Dim d2 As Double = rnd.NextDouble()
				Dim mult2 As Integer = rnd.Next(1, 10)
				d2 = d2 * mult2
				Dim sign As String = (If(mult2 Mod 2 > 0, "+", "-"))
				stock.Change = sign & d2.ToString("##0.00") & "%"

				data.Add(stock)
			Next i

			Return data.ToArray()
		End Function

		#End Region
	End Class
End Namespace